"""
Configs migration

Generation datetime: 2021-10-13 14:49:46.692618
"""

from typing import List

from configs_core.migration.db_migrate_helper import DatabaseMigrationHelper, LimitationToModify

mh: DatabaseMigrationHelper

REVISION = "a83128cf"
DOWN_REVISION = "33215e1c"


limitationsToModify: List[LimitationToModify] = [
    LimitationToModify(
        limitationName="LUNA_LICENSES_ADDRESS",
        settingUpgradeFunction=None,
        settingDowngradeFunction=None,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=["luna-admin", "luna-api"],
        newServices=["luna-admin", "luna-api", "luna-faces"],
    ),
    LimitationToModify(
        limitationName="LUNA_FACES_ADDRESS",
        settingUpgradeFunction=None,
        settingDowngradeFunction=None,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-admin",
            "luna-api",
            "luna-backport4",
            "luna-handlers",
            "luna-index-manager",
            "luna-indexed-matcher",
            "luna-indexer",
            "luna-licenses",
            "luna-tasks",
        ],
        newServices=[
            "luna-admin",
            "luna-api",
            "luna-backport4",
            "luna-handlers",
            "luna-index-manager",
            "luna-indexed-matcher",
            "luna-indexer",
            "luna-tasks",
        ],
    ),
    LimitationToModify(
        limitationName="LUNA_FACES_TIMEOUTS",
        settingUpgradeFunction=None,
        settingDowngradeFunction=None,
        # DON'T REMOVE SERVICES. Used in profiled migrations.
        oldServices=[
            "luna-api",
            "luna-backport4",
            "luna-handlers",
            "luna-index-manager",
            "luna-licenses",
            "luna-tasks",
        ],
        newServices=["luna-api", "luna-backport4", "luna-handlers", "luna-index-manager", "luna-tasks"],
    ),
]


def upgrade():
    """Upgrade configs to new revision"""

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)


def downgrade():
    """Downgrade configs to previous revision"""

    # limitations to modify
    for limitation in limitationsToModify:
        mh.migrateLimitation(limitation)
